#!/bin/sh
# Begin of libpretty.sh

#
#
#
#
# - print_status
#
#
#



# INCLUDE
include color

#
# === Begin Code
#

cutline()
{
	usage_string="usage: $FUNCNAME {nbchar}"

        if test "$#" = "0"
        then
                echo $usage_string
                return 1
        fi
	
	__content="$(cat - )"

	__size=$[$1 - 3]


	if [ "$(echo -n "$__content" | wc -c )" -gt "$[$1 - 1 ]" ];then
	    __content="$(echo -n "$__content" | cut -c -$__size).."
	else
	    __content="$(echo "$__content                                                                                                                                                                                                                                                 " | cut -c -$[$1 -1])"
	fi

	echo -en "$__content"
#	echo -en "'$__content'" >&2
}

Title()
{
	usage_string="usage: $FUNCNAME {string}"

        if test "$#" = "0"
        then
                echo $usage_string
                return 1
        fi

	echo -e "\n\n${WHITE}    $*${NORMAL}\n"
}


# Limited to 1 line long
Section()
{
	usage_string="usage: $FUNCNAME {string}"

        if test "$#" = "0"
        then
                echo $usage_string
                return 1
        fi

	__content="$(echo -n "$*" | cutline $SIZE_LINE)"
	    echo -e "\n${WHITE}$__content${NORMAL}"
	
};

Elt()
{
	usage_string="usage: $FUNCNAME {string}"

        if test "$#" = "0"
        then
                echo $usage_string
                return 1
        fi
	

	__content="$(echo -n "$*" | cutline $SIZE_ELT)"
	__elt=" - $__content"
	__info="$(echo -n "" | cutline $SIZE_INFO)"

# 	if test -z "$__elt" ;then
# 	else
# 	    echo
# 	fi

	test "$ascii_color" != "no" && echo -n "$SET_BEGINCOL$__elt${NORMAL}"
}

Feed()
{
    usage_string="usage: $FUNCNAME"

    if test "$#" -gt "0"
    then
	echo $usage_string
	return 1
    fi

    test "$ascii_color" == "yes" && echo ""
    test "$ascii_color" == "no" && echo "$__elt $__info $__status $__char"
    
};

Feedback()
{
    errorlevel="$?"

    usage_string="usage: $FUNCNAME [{fail-label} [{ok-label}  [{fail-string} [{ok-string}]]]]"

    if test "$#" -gt "5"
    then
	echo $usage_string
	return 1
    fi

    if test "$errorlevel" = "0" ; then
	test  "$4" && print_info "$4"
	test  "$4" && print_status "$2" || print_status success
    else
	test  "$3" && print_info "$3"
	test  "$1" && print_status "$1" || print_status failure
    fi

    Feed 
    __elt=""
    return $errorlevel
}

print_info()
{
	usage_string="usage: $FUNCNAME {string}"

        if test "$#" = "0" 
        then
                echo $usage_string
                return 1
        fi

	__content=$(echo -n "$*" | cutline "$SIZE_INFO")

	__info="$__content"
	
	test "$ascii_color" != "no" && echo -n "${SET_WCOL}${GRAY}$__info${NORMAL}"
};

print_info_char()
{
    usage_string="usage: $FUNCNAME {string}"
    
    if test "$#" = "0" 
    then
	echo $usage_string
	return 1
    fi

    __char=$(echo $* | cut -c 1)

    test "$ascii_color" != "no" && echo -n "${SET_LCOL}${WHITE}$__char${NORMAL}"

    
};

set_col()
{

    usage_string="usage: $FUNCNAME {number}"

    if test "$#" != "1" 
    then
	echo $usage_string
	return 1
    fi

    echo -en "\\033[${1}G";

};


print_status()
{

	usage_string="usage: $FUNCNAME {success|warning|failure|on|off|noop} {short|long} {string}"


        if test "$#" = "0"
        then
                echo $usage_string
                return 1
        fi


        if test "$2" != "short" && test "$2" != "long" && test "$#" != "1"
        then
		echo "$FUNCNAME: '$2' is a bad second argument, try : short long"
                echo $usage_string
                return 1
        fi


	type_method=$2

	if  test "$#" = "1"  
	then
	    type_method="long"
	fi


        case "$1" in
                success)
			if test "$type_method" = "long" 
			then
			    __status="[${SUCCESS}  OK  ${NORMAL}]"
			else
			    echo -n "${SUCCESS}"
			    shift; shift;
			    echo -n "$*${NORMAL}"
			fi
                        ;;
                warning)
			if test "$type_method" = "long" 
			then
			    __status="[${WARNING} ATTN ${NORMAL}]"
			else
			    echo -n "${WARNING}"
			    shift; shift;
			    echo -n "$*${NORMAL}"
			fi
                        ;;
                failure)
			if test "$type_method" = "long" 
			then
			    __status="[${FAILURE}FAILED${NORMAL}]"
			else
			    echo -n "${FAILURE}"
			    shift; shift;
			    echo -n "$*${NORMAL}"
			fi
                        ;;
		on)
			if test "$type_method" = "long" 
			then
			    __status="[${ON}  ON  ${NORMAL}]"
			else
			    echo -n "${ON}"
			    shift; shift;
			    echo -n "$*${NORMAL}"
			fi
			;;
		off)
			if test "$type_method" = "long" 
			then
			    __status="[${OFF}  OFF ${NORMAL}]"
			else
			    echo -n "${OFF}"
			    shift; shift;
			    echo -n "$*${NORMAL}"
			fi
			;;
		noop)
			if test "$type_method" = "long" 
			then
			    __status="[${NOOP}  NA  ${NORMAL}]"
			else
			    echo -n "${NOOP}"
			    shift; shift;
			    echo -n "$*${NORMAL}"
			fi
			;;


	        *)
			echo "$FUNCNAME: '$1' is a bad first argument."
        	        echo $usage_string
	                return 1
			;;

        esac

    test "$ascii_color" != "no" && echo -n "${SET_COL}$__status"
    return 0
}


# End of libpretty.sh
